FROM mcr.microsoft.com/dotnet/aspnet:8.0 AS base
WORKDIR /app
EXPOSE 80

FROM mcr.microsoft.com/dotnet/sdk:8.0 AS build
WORKDIR /src
COPY */*.csproj ./
RUN for file in $(ls *.csproj); do mkdir -p ${file%.*} && mv $file ${file%.*}; done
RUN dotnet restore "Otus.Teaching.Pcf.GivingToCustomer.WebHost/" --disable-parallel
COPY . .
RUN dotnet build "Otus.Teaching.Pcf.GivingToCustomer.WebHost/" -c Release -o /app/build

FROM build AS publish
RUN dotnet publish -c Release -o /app/publish /p:UseAppHost=false

FROM base AS final
WORKDIR /app
COPY --from=publish /app/publish ./
ENTRYPOINT ["dotnet", "Otus.Teaching.Pcf.GivingToCustomer.WebHost.dll"]